SystemOrganization addCategory: #'Gradualtalk-Compiler'!
SystemOrganization addCategory: #'Gradualtalk-Compiler--subclass creation'!

Trait named: #TTyped
	uses: {}
	category: 'Gradualtalk-Compiler'!

!TTyped classSide methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 11/27/2011 21:17'!
compilerContext
	^OTCSupport defaultCompilerContext! !

!Class methodsFor: '*Gradualtalk-Compiler' stamp: 'EstebanAllende 11/28/2011 01:55'!
subclass: t instanceVariableNames: f classVariableNames: d poolDictionaries: s category: cat 
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class (the receiver)."
	|class varParser|
	varParser :=( (VariablesParser new)
		class: t;
		ivar: f;
		cvar: d).

	class := (ClassBuilder new)
		superclass: self
		subclass: t
		instanceVariableNames: varParser oldIvar
		classVariableNames: varParser oldCvar
		poolDictionaries: s
		category: cat.
	
	"Here we must check if all old instances comply with the type specification"
	varParser annotateVars.
	^class! !

Object subclass: #CastExpr
	instanceVariableNames: 'castType implicit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Compiler'!

!CastExpr class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/5/2011 16:58'!
addCast: aCast to: aNode

	|castCollection|
	castCollection := aNode propertyAt: #cast ifAbsentPut: [OrderedCollection new].
	aCast implicit 
		ifTrue: [	castCollection addFirst: aCast.] 
		ifFalse: [castCollection addLast: aCast.].! !

!CastExpr class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/5/2011 16:58'!
explicitToType: aType

	^self new castType: aType; implicit: false; yourself.! !

!CastExpr class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/5/2011 16:59'!
toType: aType
	^self new castType: aType; implicit: true; yourself.! !

!CastExpr methodsFor: 'accessing' stamp: 'EstebanAllende 12/5/2011 16:57'!
castType

	^ castType! !

!CastExpr methodsFor: 'accessing' stamp: 'EstebanAllende 12/5/2011 16:57'!
castType: anObject

	castType := anObject! !

!CastExpr methodsFor: 'accessing' stamp: 'EstebanAllende 12/5/2011 16:57'!
implicit

	^ implicit! !

!CastExpr methodsFor: 'accessing' stamp: 'EstebanAllende 12/5/2011 16:57'!
implicit: anObject

	implicit := anObject! !

Object subclass: #OTCSupport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Gradualtalk-Compiler'!

OTCSupport class
	instanceVariableNames: 'bootstrapping'!

OTCSupport class
	instanceVariableNames: 'bootstrapping'!

!OTCSupport class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 20:27'!
bootstrapping

	^ bootstrapping ifNil: [bootstrapping := true]! !

!OTCSupport class methodsFor: 'accessing' stamp: 'EstebanAllende 11/27/2011 20:26'!
bootstrapping: anObject

	bootstrapping := anObject! !

!OTCSupport class methodsFor: 'as yet unclassified' stamp: 'EstebanAllende 12/7/2011 02:12'!
defaultASTAnalyzer

	^[:request :methodNode | 
		ASTPreprocessingVisitor new visitNode: methodNode.
		[
			OCASTSemanticAnalyzer new
				scope: request target parseScope;
				visitNode: methodNode.
		] on: OCSemanticWarning do: [:ex | ex correctIn: methodNode].
		methodNode methodClass: request target.
		ASTTypecheckVisitor new ownerClass: request target; visitNode: methodNode.
		OCASTClosureAnalyzer new visitNode: methodNode.
		"ASTCastInsertionVisitor new ownerClass: request methodClass name; visitNode: methodNode.
		OTCSupport blameLevel = #heavy ifTrue: [ASTBlameVisitor new methodClass: request methodClass; visitNode: methodNode; processQueues.].
		ASTCheckVisitor new visitNode: methodNode; processQueue."
"self halt."
	].! !

!OTCSupport class methodsFor: 'accessing' stamp: 'EstebanAllende 12/5/2011 12:10'!
defaultCompilerContext
	|bool|
	bool := self bootstrapping ifNil:[true].
	bool ifTrue: [
	^(OCCompilerContext new
		parserBlock: self defaultParser;
		astAnalyzerBlock: OCCompilerContext defaultASTAnalyzer;
		irBuilderBlock: OCCompilerContext defaultIRBuilder;
		bytecodeGeneratorBlock: OCCompilerContext defaultBytecodeGenerator;
		mapperBlock: OCCompilerContext defaultMapper;
		yourself).
	] ifFalse: [^self defaultCompilerContextForClass: thisContext sender methodClass.]! !

!OTCSupport class methodsFor: 'accessing' stamp: 'EstebanAllende 12/6/2011 23:05'!
defaultCompilerContextForClass: aClass
	^(OCCompilerContext new
		parserBlock: self defaultParser;
		astAnalyzerBlock: self defaultASTAnalyzer;
		irBuilderBlock: self defaultIRBuilder;
		bytecodeGeneratorBlock: OCCompilerContext defaultBytecodeGenerator;
		mapperBlock: OCCompilerContext defaultMapper;
		yourself).! !

!OTCSupport class methodsFor: 'accessing' stamp: 'EstebanAllende 12/6/2011 23:06'!
defaultIRBuilder
	^[:request :methodNode | 
		|ir md|
		ir := (OCASTTranslator new
			visitNode: methodNode)
			ir.
			md := MethodDeclaration new.
			md type: (methodNode propertyAt: #methodType).
			TypeDictionary uniqueInstance class: request target atSelector: methodNode selector putMethodDeclaration: md.
			ir]! !

!OTCSupport class methodsFor: 'accessing' stamp: 'EstebanAllende 1/24/2013 18:15'!
defaultParser

	^[:request | (GradualtalkParser new) 
							parse: request sourceStream contents
	 						onError: [ :msg :pos | self error: msg ]].! !
